#
# Pu-roxy ư
#
# Copyright (c) 2003-2004 Satoshi Fukutomi <fuktommy@inter7.jp>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: System.pm,v 1.4 2005/01/02 04:55:13 fuktommy Exp $
#

package Pu::System;
use IPC::Open2;
use Pu::Config;

$AGENT = "Monazilla/1.0 (Pu-roxy/0.2)";

#----------------------------------------------------------------------#
# URL󥳡
# : ʸ
# : 󥳡ɤʸ
sub encode($) {
	my($s) = @_;
	$s =~ s|[^\w ]|'%' . uc(unpack('H2', $&))|eg;
	$s =~ s| |+|g;
	return $s;
}

#----------------------------------------------------------------------#
# եΥ(ʬΤ)
# : URL
# : ɤ
sub sync($) {
	my($url) = @_;
	checkMove($url);
	my $file = $url;
	$file =~ s|http://||;
	#$file =~ s|~|%7E|g;
	$file = $Pu::Config::cacheDir . "/" .  $file;
	return update($url) unless (-e $file);
	my $code = system $Pu::Config::wget,
		"-q", "-U", $AGENT, "-c", "-x",
		"-Y", "off",
		"-T", $Pu::Config::timeout, "-t", "1",
		"-P", $Pu::Config::cacheDir, $url;
	return !$code;
}

#----------------------------------------------------------------------#
# եΥ()
# : URL
# : ɤ
sub get($) {
	my($url) = @_;
	checkMove($url);
	my $code = system $Pu::Config::wget,
		"-q", "-U", $AGENT, "-x",
		"-T", $Pu::Config::timeout, "-t", "1",
		"-Y", "off", "-N",
		"--header=Accept-Encoding: gzip",
		"-P", $Pu::Config::cacheDir, $url;
	gunzip($url) if ($code == 0);
	return !$code;
}

#----------------------------------------------------------------------#
# եΥ()
# : URL
# : ɤ
sub update($) {
	my($url) = @_;
	checkMove($url);
	my $code = system $Pu::Config::wget,
		"-q", "-U", $AGENT, "-x",
		"-T", $Pu::Config::timeout, "-t", "1",
		"-Y", "off",
		"--header=Accept-Encoding: gzip",
		"-P", $Pu::Config::cacheDir, $url;
	gunzip($url) if ($code == 0);
	return !$code;
}

#----------------------------------------------------------------------#
# åɤǽ(˥塼)
# : URL
sub printMenu($) {
	my($url) = @_;
	$url =~ s|http://||;
	#$url =~ s|~|%7E|g;
	my $file = $Pu::Config::cacheDir . "/" .  $url;
	Pu::Document::printHeader("2ch menu");
	print "<BODY><UL>\n",
	      "<LI><A href='$main::pu?mode=cache'>Cache</A>\n",
	      "<LI><A href='$main::pu?mode=tcache'>Cache(sort by timestamp)</A>\n",
	      "<LI><A href='$main::pu?mode=search'>Search</A>\n";
	local $_;
	my $stat_comment = 0;
	open IN, $file;
	my @buf = <IN>;
	close IN;
	while (@buf) {
		$_ = shift @buf;
		if (/<!--/ && (! /-->/)) {
			$stat_comment = 1;
		} elsif ($stat_comment && /-->/) {
			$stat_comment = 0;
		} elsif ($stat_comment) {
			next;
		} elsif (m|^<A HREF=http://[^.]*\.2ch\.net/|i ||
		    m|^<A HREF=http://[^.]*\.bbspink\.com/|i) {
			s| TARGET=".*"||i;
			s|HREF=http://|href="$main::pu?url=|;
			s|<BR>||gi;
			s|>|">|;
			print "<LI>$_";
		} elsif (m|<B>(.*)</B>|i) {
			print "</UL><H3>$1</H3><UL>\n";
			unshift @buf, $';
		} elsif (m|^(<BR>)*<A HREF.*</A>|i) {
			s|<BR>||gi;
			s|HREF=|href="|;
			s| *TARGET=_blank||;
			s|>|">|;
			print "<LI>$_";
		}
	}
	print "</UL></BODY></HTML>";
}

#----------------------------------------------------------------------#
# Ĥɤ߹
# : URL
sub readSubject($) {
	my($url) = @_;
	$url =~ s|http://||;
	#$url =~ s|~|%7E|g;
	my $file = $Pu::Config::cacheDir . "/" .  $url;
	my @num  = ();
	my %name = ();
	local $_;
	open IN, $file;
	while (<IN>) {
		chomp;
		if (m|^(\d+)\.dat<>|) {
			my($num, $thread) = ($1, $');
			$thread =~ s/&/&amp;/g;
			$thread =~ s/([gl])t;/&$1t;/g;
			$thread =~ s/&amp;&([gl])t;/&$1t;/g;
			$name{$num} = $thread;
			push @num, $num;
		}
	}
	return \@num, \%name;
}

#----------------------------------------------------------------------#
# åɤǽ()
# : URL, ľΥǡ
sub printSubject($$) {
	my($url, $old) = @_;
	my($num, $new) = readSubject($url);
	my($bbsName, $base) = getBbsName($url);
	Pu::Document::printHeader($bbsName);
	print "<BODY><H1>$bbsName</H1><UL>\n";
	local $_;
	foreach (@$num) {
			print "<LI><A href='$main::pu?url=${base}dat/$_.dat'>$$new{$_}</A>";
			print " [New!]" unless ($$old{$_});
			print "</LI>\n";
	}
	close IN;
	print "</UL></BODY></HTML>";
}

#----------------------------------------------------------------------#
# åɤǽ()
# : URL
sub printDat($) {
	my($url) = @_;
	$url =~ s|http://||;
	#$url =~ s|~|%7E|g;
	my $link = $url;
	$link =~ s|(\w+)/dat|test/read.cgi/$1|;
	$link =~ s|\.dat$|/l50|;
	my $file = $Pu::Config::cacheDir . "/" .  $url;
	open IN, $file;
	my @buf = <IN>;
	close IN;
	chomp @buf;
	@_ = split /<>/, $buf[0];
	my $title = $_[4];
	if ($title) {
		$title =~ s/&/&amp;/g;
		$title =~ s/([gl])t;/&$1t;/g;
		$title =~ s/&amp;&([gl])t;/&$1t;/g;

		my %title = readTitle();
		unless ($title{$url}) {
			addTitle($url, $title);
		}
	}
	local $_;
	my $i=0;
	Pu::Document::printHeader($title);
	unless ($title) {
	        my $link = $url;
		$link =~ s|dat/\d+.dat||;
		$title = "<A href='$main::pu?url=$link'>$link</A>";
	}
	print "<BODY><H1>$title</H1><DL>\n";
	foreach (@buf) {
		$i++;
		local @_ = split /<>/;
		my($name, $mail, $date, $cont) = @_;
		$name = "<SPAN class='name'>$name</SPAN>";
		$name =~ s|<b>|<SPAN class='name'>|g;
		$name =~ s|</b>|</SPAN>|g;
		$name =~ s|<SPAN[^>]*> *</SPAN>||ig;
		$date =~ s|<a.[^>]*i=(\d+)[^>]*>|<a href='http://be.2ch.net/test/p.php?i=$1&amp;u=d:http://$link'>|;
		$cont = plastic($cont);
		print "<DT id='r$i'>$i :$name",
		      " [$mail] $date<DD>$cont<BR><BR>\n";
	}
	if ($i == 0) {
		print "<DT>DAT? HTML?";
		my $kako = $url;
		$kako =~ s|(\w+)/dat|test/read.cgi/$1|;
		$kako =~ s|\.dat$|/l50|;
		print "<DD><A href='http://$kako'>http://$kako</A>";
	}
	print "</DL>";
	print "<P><A href='http://$link'>read.cgi</A> | ",
	      "<A href='http://info.2ch.net/test/tb.cgi?__mode=list&amp;tb_id=http://$link'>TrackBack</A> | ",
	      "<A href='$main::pu?mode=post&amp;url=$url'>Post</A> | ",
	      "<A href='$main::pu?mode=update&amp;url=$url'>Force-Update</A> | ",
	      "<A href='$main::pu?mode=remove&amp;url=$url'>Remove</A></P>",
	      "</BODY></HTML>\n";
}

#----------------------------------------------------------------------#
# ȥɤ߹
sub readTitle() {
	local $_;
	my %name = ();
	my $titleData = $Pu::Config::cacheDir . "/title.txt";
	open IN, $titleData;
	while (<IN>) {
		chomp;
		local @_ = split /\s+|<>/, $_, 2;
		$name{$_[0]} = $_[1];
	}
	close IN;
	return %name;
}

#----------------------------------------------------------------------#
# ȥɲ
sub addTitle($$) {
	my($url, $name) = @_;
	my $titleData = $Pu::Config::cacheDir . "/title.txt";
	open OUT, ">> $titleData";
	print OUT "$url<>$name\n";
	close OUT;
}

#----------------------------------------------------------------------#
# 
# : ʸ
# : ʸ
sub plastic($) {
	my($cont) = @_;
	$cont =~ s/<a.*?>|<\/a>//ig;
	$cont =~ s/(&gt;&gt;|>>|\201\204|\201\164|\201\342|&gt;)(\d+)/<a href='#r$2'>$&<\/a>/g;
	$cont =~ s|https?://[\041-\073\075-\177]{2,}|<a href='$&'>$&<\/a>|g;
	$cont =~ s|([^h])(ttps?://[\041-\073\075-\177]{2,})|$1<a href='h$2'>$2<\/a>|g;
	$cont =~ s|<a href='(http://[^>]*?\.2ch\.net/[^>]*?)'[^>]*?>|<a href='$main::pu?url=$1'>|g;
	$cont =~ s|<a href='(http://[^>]*?\.bbspink\.com/[^>]*?)'[^>]*?>|<a href='$main::pu?url=$1'>|g;
	return $cont;
}

#----------------------------------------------------------------------#
# Ĥΰưб
# : URL
sub checkMove($) {
	my($url) = @_;
	$url =~ s|http://||;
	#$url =~ s|~|%7E|g;
	my $dir = $Pu::Config::cacheDir;
	local @_ = split /\//, $url;
	my $host = $_[0];
	my $bbs  = $_[1];
	local $_;
	foreach (glob "$dir/*") {
		if ($_ eq "$dir/$host") {
			next;
		} elsif (-d "$_/$bbs") {
			mkdir "$dir/$host", 0777 unless (-d "$dir/$host");
			rename "$_/$bbs", "$dir/$host/$bbs";
			last;
		}
	}
}

#----------------------------------------------------------------------#
# å
# : ץ(sort=>file, sort=>stamp)
sub cache(;%) {
	my %opt = @_;
	my $file = $Pu::Config::cacheDir . "/title.txt";
	local $_;
	Pu::Document::printHeader("2ch cache");
	print "<BODY><H1>2ch cache</H1><UL>\n";
	my @line = ();
	open IN, $file;
	my @thread = ();
	while (<IN>) {
		chomp;
		local @_ = split /\s+|<>/, $_, 2;
		$_[1] =~ s/&/&amp;/g;
		$_[1] =~ s/([gl])t;/&$1t;/g;
		$_[1] =~ s/&amp;&([gl])t;/&$1t;/g;
		my @stat = stat($Pu::Config::cacheDir . "/" . $_[0]);
		my $t = { file  => $_[0],
			  name  => $_[1],
			  stamp => $stat[9],};
		push @thread, $t;
	}
	close IN;
	if ($opt{sort} eq "stamp") {
		@thread = sort {$$b{stamp} <=> $$a{stamp}} @thread;
	} else {
		@thread = sort {$$a{file} cmp $$b{file}} @thread;
	}
	foreach (@thread) {
		print "<LI><A href='$main::pu?url=$$_{file}'>$$_{name}</A>\n";
	}
	print "</UL></BODY></HTML>";
}

#----------------------------------------------------------------------#
# gunzip
# : URL
sub gunzip($) {
	my($url) = @_;
	$url =~ s|http://||;
	#$url =~ s|~|%7E|g;
	my $file = $Pu::Config::cacheDir . "/" .  $url;
	rename $file, "$file.gz";
	system $Pu::Config::gzip, "-d", "-q", $file . ".gz";
	if (-e "$file.gz") {
		rename "$file.gz", $file;
	}
}

#----------------------------------------------------------------------#
# ĤΰĤ̾ʤɤ򸡺
# : URL
# : Ĥ̾, ĤURL
sub getBbsName($) {
	my($url) = @_;
	$url =~ s|//*subject.txt|/|;
	my $bbsName;
	my $menuURL = $Pu::Config::menuURL;
	$menuURL =~ s|http://||;
	#$menuURL =~ s|~|%7E|g;
	open IN, $Pu::Config::cacheDir . "/" .  $menuURL;
	while (<IN>) {
		if (m|^<A HREF=http://$url>(.+)</A>|i) {
			$bbsName = $1;
		}
	}
	close IN;
	return ($bbsName, $url);
}

#----------------------------------------------------------------------#
# åκ
# : URL
sub remove($) {
	my($url) = @_;
	unlink $Pu::Config::cacheDir . "/" .  $url;
	my $titleData = $Pu::Config::cacheDir . "/title.txt";
	open IN, $titleData;
	my @buf = <IN>;
	close IN;
	chomp @buf;

	open OUT, "> $titleData";
	local $_;
	foreach (@buf) {
		@_ = split /\s+|<>/, $_, 2;
		#if (-e "$Pu::Config::cacheDir/$_[0]") {
		if ($_[0] ne $url) {
			print OUT "$_[0]<>$_[1]\n";
		}
	}
	close OUT;
	print "Content-Type: text/plain\n\n",
	      "Removed\n";
}

#----------------------------------------------------------------------#
# 
# : ñ
sub search($$) {
	my($key, $offset) = @_;
	$key = "" unless (defined $key);
	$key =~ s/"/&quote;/g;
	$offset = 0 unless ($offset);
	my $str_key = encode($key);
	Pu::Document::printHeader("Search", "EUC-JP");
	print "<BODY><FORM method='get' action='$main::pu'><P>",
	      "<INPUT name='key' value=\"$key\" tabindex=1 accesskey='k'>",
	      "<INPUT type='submit' name='submit' value='search' tabindex=2 accesskey='s'>",
	      "<INPUT type='hidden' name='mode' value='search'>",
	      "</P></FORM>";

	if ($key ne "") {
		my $count = $Pu::Config::search_count;
		print "<UL>\n";
		my($IN, $OUT);
		open2 $IN, $OUT, $Pu::Config::wget, "-q", "-U", $AGENT, "-O", "-",
			"-Y", "off", "-T", $Pu::Config::timeout, "-t", "1",
			"http://find.2ch.net/?BBS=ALL&TYPE=TITLE&STR=$str_key&COUNT=$count&OFFSET=$offset";
		close $OUT;
		local $_;
		my $n=0;
		while (<$IN>) {
			if (m|^<dt><a href=["']?http://([^/]+)/test/read\.cgi/([^/]+)/(\d+).*<b>([^>]+)</b></a> \((\d+)\)|) {
				print "<LI><A href='$main::pu?url=$1/$2/dat/$3.dat'>$4 ($5)</A></LI>\n";
				$n++;
			}
		}
		close $IN;
		wait;
		print "</UL><P>";
		if ($offset > 0) {
			print "<A href='$main::pu?mode=search&amp;key=$str_key&amp;off=", $offset-$count ,"'>",
			      "Prev</A>";
		} else {
			print "....";
		}
		print " | ";
		if ($n >= $count) {
			print "<A href='$main::pu?mode=search&amp;key=$str_key&amp;off=", $offset+$count, "'>",
			      "Next</A>";
		} else {
			print "....";
		}
		print "</P>";
	}
	print "</BODY></HTML>\n";
}

1;
